=== debian/changelog ===
tcc (0.9.27~git20140923.9d7fb33-3ubuntu1) wily; urgency=medium

  * Disable stack protection on i386 to avoid FTBFS with
    undefined symbol '__stack_chk_fail_local' (LP: #1500147).

 -- Graham Inggs <graham@nerve.org.za>  Sun, 27 Sep 2015 08:17:02 +0200

tcc (0.9.27~git20140923.9d7fb33-3) unstable; urgency=low

  * New patch to fix tests2 on armel.

 -- Matteo Cypriani <mcy@lm7.fr>  Fri, 17 Oct 2014 15:29:00 -0400

tcc (0.9.27~git20140923.9d7fb33-2) unstable; urgency=low

  * Deactivate one more test for armel again.

 -- Matteo Cypriani <mcy@lm7.fr>  Thu, 09 Oct 2014 09:44:01 -0400

tcc (0.9.27~git20140923.9d7fb33-1) unstable; urgency=low

  * New upstream snapshot.
  * Deactivate kfreebsd builds.
  * Deactivate one more test for armel.
  * debian/copyright: update packaging authors.
  * Bump Standards-Version to 3.9.6 (no changes needed).
  * Fix cleaning (revert changes on examples' shebang).

 -- Matteo Cypriani <mcy@lm7.fr>  Wed, 08 Oct 2014 10:16:49 -0400

tcc (0.9.27~git20140907.87d879a-1) unstable; urgency=medium

  * New upstream snapshot.
  * Stop overriding LDFLAGS for the tests, since it is now done upstream.
  * debian/patches:
    + Disable BTESTS completely.
    + Disable floating-point test for ARM soft-float: disable one more test.

 -- Matteo Cypriani <mcy@lm7.fr>  Sun, 07 Sep 2014 12:51:32 -0400

tcc (0.9.27~git20140801.14745bd-1) unstable; urgency=medium

  * New upstream snapshot.
  * Upload to unstable.
  * Add Matteo Cypriani as an Uploader.
  * Bump Standards-Version to 3.9.5.
  * Improve watch file (thanks Bart Martens).
  * Switch from texi2html to makeinfo.
  * Override LDFLAGS for the tests.
  * Disable floating-point test for armel.

 -- Matteo Cypriani <mcy@lm7.fr>  Fri, 05 Sep 2014 23:35:30 -0400

tcc (0.9.26-1) experimental; urgency=low

  * New upstream release:
    + Add support for hardfloat calling convention (Closes: #645692).
  * debian/rules:
    + Use DEB_HOST_ARCH to set the default ABI (Closes: #651840).
    + Directly install tcc-doc.html in the right directory instead of relying
      on dh_installdocs.
    + Scripts in /usr/share/doc/tcc/examples contain correct interpreter path
      again.
  * debian/control:
    + Enable build on armhf. (Closes: #645673, thanks Loïc Minier).
    + Update my maintainer email address.
    + Remove Arthur Loiret from Uploaders, as agreed.
    + Remove DMUA flag: it's both unneeded (DD maintenance) and useless now
      (http://lists.debian.org/debian-devel-announce/2012/11/msg00006.html).
  * debian/copyright:
    + Update copyright and licenses according to what has changed in this new
      release and reformat Copyright entries.
    + Update my maintainer email address.
  * debian/patches:
    + Allow preprocessor flags to be passed to upstream Makefile through
      environment.
  * Remove unused lintian overrides about incorrect interpreter and lack of
    fortification.

 -- Thomas Preud'homme <robotux@debian.org>  Sat, 16 Feb 2013 20:05:48 +0100
